;;; Sierra Script 1.0 - (do not remove this comment)
;
; * SCI Game Header
; *************************************************************************
; * Put all the defines specific to your game in here
(include Verbs.sh)
(include Talkers.sh)

; e.g.
(define MAIN_SCRIPT 0)
(define INGAME_DEBUG_SCRIPT 10)
(define DISPOSECODE_SCRIPT 11)
(define COLORINIT_SCRIPT 12)
(define ABOUT_SCRIPT 13)
(define DEBUGOUT_SCRIPT 14)
(define INVENTORY_SCRIPT 15)
(define DEBUGROOM_SCRIPT 16)
(define DEATH_SCRIPT 20)
(define PRITALKER_SCRIPT 22)
(define GAMECONTROLS_SCRIPT 24)
(define VELOCITYMOVER_SCRIPT 25)
(define ANIMDIALOG_SCRIPT 30)
(define SPEAKWINDOW_SCRIPT 877)
(define INSET_SCRIPT 923)
(define MESSAGEOBJ_SCRIPT 925)
(define FLIPPOLY_SCRIPT 926)
(define PATHAVOIDER_SCRIPT 927)
(define PATHFOLLOW_SRIPT 932)
(define SLIDER_SCRIPT 934)
(define OSCILLATE_SCRIPT 939)
(define MANUALCYCLE_SCRIPT 942)
(define POLYGONEDIT_SCRIPT 943)
(define DIALOGEDIT_SCRIPT 947)
(define FEATUREWRITER_SCRIPT 948)
(define MOVEFORWARD_SCRIPT 951)
(define DOOR_SCRIPT 954)
(define FORWARDCOUNT_SCRIPT 956)
(define DISPOSELOAD_SCRIPT 958)
(define DIRECTPATH_SCRIPT 964)
(define REVERSECYCLE_SCRIPT 969)
(define SCALETO_SRIPT 975)
(define CONTROLSBASE_SCRIPT 978)
(define SAVERESTORE_SCRIPT 990)
(define FILE_SCRIPT 993)
(define TITLEROOM_SCRIPT 100)
(define FLOPPYDISK_REGION 800)
(define SNOWY_REGION 801)
(define DEATH_REGION 802)
; Talkers
(define YOUTHINK_SRIPT 1100)
(define AUDIOGUIDE_SCRIPT 1101)
(define DEATHWOMANTALKER_SCRIPT 1102)
; Indices for the icons in the icon bar
(define ICONINDEX_WALK 0)
(define ICONINDEX_LOOK 1)
(define ICONINDEX_DO 2)
(define ICONINDEX_TALK 3)
(define ICONINDEX_CUSTOM 4)
(define ICONINDEX_CURITEM 5)
(define ICONINDEX_INVENTORY 6)
(define ICONINDEX_SETTINGS 7)
(define ICONINDEX_HELP 8)
; Flags
(define F_TurnedOnLight 0)
(define F_TurnedOnTV 1)
(define F_WalkedToTV 2)
(define F_SupplyCloset 3)
(define F_TransitionRoom 4)
(define F_TransitionRoomExit 5)
(define F_PickedUpFloppy 6)
(define F_DestroyedElectricPost 7)
(define F_PickedUpMug 8)
(define F_PickedUpSalt 9)
(define F_Puzzle_First 10)
(define F_Puzzle_Last 18)
(define F_FilledMugWithWater 25)
(define F_PutSaltInMug 26)
(define F_PressedGreenButton 27)
(define F_PressedRedButton 28)
(define F_DeathType 30)
; Leave room for at leaast 10 items after F_DeathType
(define F_MovedPaintingOnce 40)
(define F_MovedPainting 41)
; Inventory items
(define INV_FLOPPY 0)
(define INV_EMPTYMUG 1)
(define INV_FULLMUG 2)
(define INV_SALTYFULLMUG 3)
(define INV_SALT 4)
(define INV_AUDIOGUIDE 5)
; death types
(define DEATH_HEADEXPLOSION 1)
(define DEATH_FREEZING 2)
(define DEATH_MELTING 3)
(define DEATH_ELECTROCUTION 4)
(define DEATH_FLATTENING 5)
