;;; Sierra Script 1.0 - (do not remove this comment)
(script# 136)
(include sci.sh)
(include game.sh)
(include 136.shm)
(include 136.shp)
(use Controls)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use System)
(use Polygon)
(public
	rm136 0
)

(instance rm136 of Room
	(properties
		picture scriptNumber
		north 0
		east 135
		south 0
		west 0
		noun N_ROOM
		style dpOPEN_NO_TRANSITION
	)
	
	(method (init)
		(self setRegions: DEATH_REGION FLOPPYDISK_REGION)
		(AddPolygonsToRoom @P_Default136)
		; To control the transition based on the source room, set the style
		; prior to calling super:init
		(switch gPreviousRoomNumber
			(135 (= style dpOPEN_SCROLL_RIGHT))
			(137 (= style dpOPEN_BOTTOM))
		)
		(super init:)
		(self setScript: RoomScript)
		(SetUpEgo)
		(switch gPreviousRoomNumber
			(else  (gEgo posn: 290 55 loop: 1))        ; 135
			(137 (gEgo posn: 145 46 loop: 2))
		)
		(gEgo init:)
		((Feature new:)
			noun: N_SIGN
			x: 261
			y: 63
			approachDist: 20
			approachVerbs: V_DO
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_Sign)
			init:
		)
	)
)

(instance RoomScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (& ctlGREEN (gEgo onControl:))
			(gRoom newRoom: 137)
		)
	)
	
	(method (handleEvent pEvent)
		(super handleEvent: pEvent)
	)
	
	; handle Said's, etc...
	(method (changeState newState)
		(= state newState)
		(switch state
			(0)
		)
	)
)
