;;; Sierra Script 1.0 - (do not remove this comment)
(script# 137)
(include sci.sh)
(include game.sh)
(include 137.shm)
(include 137.shp)
(use Controls)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use System)
(use Polygon)
(public
	rm137 0
)

(instance rm137 of Room
	(properties
		picture scriptNumber
		north 0
		east 0
		south 136
		west 0
		noun N_ROOM
		style dpOPEN_NO_TRANSITION
	)
	
	(method (init)
		(AddPolygonsToRoom @P_Default137)
		; To control the transition based on the source room, set the style
		; prior to calling super:init
		(switch gPreviousRoomNumber
			(136 (= style dpOPEN_TOP))
		)
		(super init:)
		(self setScript: RoomScript)
		(SetUpEgo)
		(switch gPreviousRoomNumber
			(else  (gEgo posn: 74 180 loop: 6))        ; 136
			(140 (gEgo posn: 142 159 loop: 5))
		)
		(gEgo init:)
		(ScoreFlag F_SupplyCloset 1)
	)
)

(instance RoomScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (& ctlTEAL (gEgo onControl:)) (gRoom newRoom: 140))
	)
	
	(method (handleEvent pEvent)
		(super handleEvent: pEvent)
	)
	
	; handle Said's, etc...
	(method (changeState newState)
		(= state newState)
		(switch state
			(0)
		)
	)
)
