;;; Sierra Script 1.0 - (do not remove this comment)
(script# 209)
(include sci.sh)
(include game.sh)
(include 209.shm)
(include 209.shp)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use System)
(use Polygon)
(use View)
(public
	rm209 0
)

(instance rm209 of Room
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
		noun N_ROOM
	)
	
	(method (init)
		(AddPolygonsToRoom @P_Default209)
		(super init:)
		(self setScript: RoomScript)
		(switch gPreviousRoomNumber
			(else  (SetUpEgo -1 2) (gEgo posn: 147 105))
			; Set up ego view and loop (direction)
			(210 (SetUpEgo -1 3) (gEgo posn: 147 144))
		)                            
		(gEgo init:)
	)
)

(instance RoomScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (& ctlNAVY (gEgo onControl:)) (gRoom newRoom: 110))
		(if (& ctlGREEN (gEgo onControl:))
			(gRoom newRoom: 210)
		)
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0)
		)
	)
)
