;;; Sierra Script 1.0 - (do not remove this comment)
(script# MESSAGEOBJ_SCRIPT)
(include sci.sh)
(include game.sh)
(use Main)
(use Print)
(use System)


(class MessageObj of Object
	(properties
		modNum -1
		noun 0
		verb 0
		case 0
		sequence 0
		whoSays 0
		client 0
		caller 0
		font 0
		x 0
		y 0
	)
	
	(method (showSelf &tmp [temp0 40])
		(= whoSays
			(gMessager
				findTalker:
					(Message
						msgGET
						modNum
						noun
						verb
						case
						(if sequence else 1)
					)
			)
		)
		(if (not (IsObject whoSays))
			(Print
				addTextF:
					{<MessageObj> Message not found: %d - %d, %d, %d, %d}
					modNum
					noun
					verb
					case
					sequence
				init:
			)
			(= gQuitGame TRUE)
		else
			(if font (whoSays font: font))
			(if (or x y) (whoSays x: x y: y))
			(gMessager say: noun verb case sequence caller modNum)
		)
	)
)

; This seems to be a class to which you can add a series of messages that will be displayed one
; after another. gMessager can do the same thing.
(class Conversation of List
	(properties
		elements 0
		size 0
		script 0
		curItem -1
		caller 0
	)
	
	(method (init theCaller)
		(= curItem -1)
		(if (and argc (IsObject theCaller))
			(= caller theCaller)
		)
		(gTheDoits add: self)
		(self cue:)
	)
	
	(method (doit)
		(if script (script doit:))
	)
	
	(method (dispose &tmp theCaller)
		(self eachElementDo: #perform cleanCode)
		(gTheDoits delete: self)
		(if gDialog (gDialog dispose:))
		(if script (= script 0))
		(= theCaller caller)
		(super dispose:)
		(if theCaller (theCaller cue:))
	)
	
	(method (add theTheGModNum_2 &tmp theGModNum theTheGModNum theTheTheGModNum theTheTheGModNum_2 theTheTheGModNum_2_2 theTheTheGModNum_2_3 theTheTheGModNum_2_4 theTheTheGModNum_2_5)
		(= theTheTheGModNum_2_2 0)
		(= theTheTheGModNum_2 theTheTheGModNum_2_2)
		(= theTheTheGModNum theTheTheGModNum_2)
		(= theTheGModNum theTheTheGModNum)
		(= theGModNum theTheGModNum)
		(= theTheTheGModNum_2_5 0)
		(= theTheTheGModNum_2_4 theTheTheGModNum_2_5)
		(= theTheTheGModNum_2_3 theTheTheGModNum_2_4)
		(if (and argc (not (IsObject [theTheGModNum_2 0])))
			(= theGModNum [theTheGModNum_2 0])
			(if (== theGModNum -1) (= theGModNum gRoomNumber))
			(if (> argc 1)
				(= theTheGModNum [theTheGModNum_2 1])
				(if (> argc 2)
					(= theTheTheGModNum [theTheGModNum_2 2])
					(if (> argc 3)
						(= theTheTheGModNum_2 [theTheGModNum_2 3])
						(if (> argc 4)
							(= theTheTheGModNum_2_2 [theTheGModNum_2 4])
							(if (> argc 5)
								(= theTheTheGModNum_2_3 [theTheGModNum_2 5])
								(if (> argc 6)
									(= theTheTheGModNum_2_4 [theTheGModNum_2 6])
									(if (> argc 7)
										(= theTheTheGModNum_2_5 [theTheGModNum_2 7])
									)
								)
							)
						)
					)
				)
			)
			(if (not (IsObject [theTheGModNum_2 0]))
				(super
					add:
						((MessageObj new:)
							modNum: theGModNum
							noun: theTheGModNum
							verb: theTheTheGModNum
							case: theTheTheGModNum_2
							sequence: theTheTheGModNum_2_2
							x: theTheTheGModNum_2_3
							y: theTheTheGModNum_2_4
							font: theTheTheGModNum_2_5
							yourself:
						)
				)
			)
		else
			(super add: theTheGModNum_2 &rest)
		)
	)
	
	(method (cue param1 &tmp temp0 temp1)
		(if (or (and argc param1) (== (++ curItem) size))
			(self dispose:)
		else
			(= temp0 (self at: curItem))
			(cond 
				((temp0 isKindOf: MessageObj) (temp0 caller: self showSelf:))
				((temp0 isKindOf: Script) (self setScript: temp0 self))
				((IsObject temp0) (temp0 doit: self))
				(else (self cue:))
			)
		)
	)
	
	(method (setScript theScript)
		(if (IsObject script) (script dispose:))
		(if theScript (theScript init: self &rest))
	)
	
	(method (load param1 &tmp theGModNum temp1 temp2 temp3 temp4 temp5 temp6 temp7 temp8)
		(= theGModNum (GetValueAt param1 0))
		(= temp1 (GetValueAt param1 1))
		(= temp2 (GetValueAt param1 2))
		(= temp3 (GetValueAt param1 3))
		(= temp4 (GetValueAt param1 4))
		(= temp5 (GetValueAt param1 5))
		(= temp6 (GetValueAt param1 6))
		(= temp7 (GetValueAt param1 7))
		(= temp8 7)
		(while theGModNum
			(if (== theGModNum -1) (= theGModNum gRoomNumber))
			(self
				add: theGModNum temp1 temp2 temp3 temp4 temp5 temp6 temp7
			)
			(= theGModNum (GetValueAt param1 (++ temp8)))
			(= temp1 (GetValueAt param1 (++ temp8)))
			(= temp2 (GetValueAt param1 (++ temp8)))
			(= temp3 (GetValueAt param1 (++ temp8)))
			(= temp4 (GetValueAt param1 (++ temp8)))
			(= temp5 (GetValueAt param1 (++ temp8)))
			(= temp6 (GetValueAt param1 (++ temp8)))
			(= temp7 (GetValueAt param1 (++ temp8)))
		)
	)
)

(instance cleanCode of Code
	(properties)
	
	(method (doit param1 &tmp temp0)
		(if (param1 isKindOf: Script) (param1 caller: 0))
		(if
			(and
				(param1 isKindOf: MessageObj)
				(IsObject (= temp0 (param1 whoSays?)))
				(temp0 underBits?)
			)
			(temp0 dispose: 1)
		)
	)
)
