;;; Sierra Script 1.0 - (do not remove this comment)
(script# OSCILLATE_SCRIPT)
(include sci.sh)
(include game.sh)
(use Cycle)


(class Oscillate of Cycle
	(properties
		client 0
		caller 0
		cycleDir 1
		cycleCnt 0
		completed 0
		howManyCycles -1
	)
	
	(method (init param1 theHowManyCycles theCaller)
		(if (>= argc 2)
			(= howManyCycles theHowManyCycles)
			(if (>= argc 3) (= caller theCaller))
		)
		(super init: param1)
	)
	
	(method (doit &tmp oscNextCel)
		(= oscNextCel (self nextCel:))
		(if (or (> oscNextCel (client lastCel:)) (< oscNextCel 0))
			(= cycleDir (- cycleDir))
			(self cycleDone:)
		else
			(client cel: oscNextCel)
		)
	)
	
	(method (cycleDone)
		(if howManyCycles
			(client cel: (self nextCel:))
			(if (> howManyCycles 0) (-- howManyCycles))
		else
			(= completed 1)
			(self motionCue:)
		)
	)
)
